import * as React from 'react';
import { ReactElement } from 'react';
import PropTypes from 'prop-types';
import { MutationMode, RaRecord, UpdateManyParams } from 'ra-core';
import { ButtonProps } from './Button';
import { BulkActionProps } from '../types';
import { UseMutationOptions } from 'react-query';
export declare const BulkUpdateWithConfirmButton: {
    (props: BulkUpdateWithConfirmButtonProps): JSX.Element;
    propTypes: {
        confirmTitle: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        confirmContent: PropTypes.Requireable<PropTypes.ReactNodeLike>;
        label: PropTypes.Requireable<string>;
        resource: PropTypes.Requireable<string>;
        selectedIds: PropTypes.Requireable<any[]>;
        icon: PropTypes.Requireable<PropTypes.ReactElementLike>;
        data: PropTypes.Validator<any>;
        mutationMode: PropTypes.Requireable<string>;
    };
};
export interface BulkUpdateWithConfirmButtonProps<RecordType extends RaRecord = any, MutationOptionsError = unknown> extends BulkActionProps, ButtonProps {
    confirmContent?: React.ReactNode;
    confirmTitle?: React.ReactNode;
    icon?: ReactElement;
    data: any;
    onSuccess?: () => void;
    onError?: (error: any) => void;
    mutationMode?: MutationMode;
    mutationOptions?: UseMutationOptions<RecordType, MutationOptionsError, UpdateManyParams<RecordType>> & {
        meta?: any;
    };
}
//# sourceMappingURL=BulkUpdateWithConfirmButton.d.ts.map