/// <reference types="react" />
import { RaThemeOptions } from '../theme';
/**
 * Button toggling the theme (light or dark).
 *
 * @deprecated Set the lightTheme and darkTheme props in the <Admin> component.
 *
 * @example
 * import { AppBar, TitlePortal, ToggleThemeLegacyButton } from 'react-admin';
 *
 * const MyAppBar = () => (
 *     <AppBar>
 *         <TitlePortal />
 *         <ToggleThemeButton lightTheme={lightTheme} darkTheme={darkTheme} />
 *     </AppBar>
 * );
 *
 * const MyLayout = props => <Layout {...props} appBar={MyAppBar} />;
 */
export declare const ToggleThemeLegacyButton: (props: ToggleThemeLegacyButtonProps) => JSX.Element;
export interface ToggleThemeLegacyButtonProps {
    darkTheme: RaThemeOptions;
    lightTheme?: RaThemeOptions;
}
//# sourceMappingURL=ToggleThemeLegacyButton.d.ts.map