import { ReactNode } from 'react';
import { TypographyProps } from '@mui/material/Typography';
import { FieldProps } from './types';
/**
 * Field using a render function
 *
 * @example
 * <FunctionField
 *     source="last_name" // used for sorting
 *     label="Name"
 *     render={record => `${record.first_name} ${record.last_name}`}
 * />
 */
export declare const FunctionField: {
    <RecordType extends Record<string, any> = any>(props: FunctionFieldProps<RecordType>): JSX.Element;
    propTypes: any;
};
export interface FunctionFieldProps<RecordType extends Record<string, any> = any> extends FieldProps<RecordType>, Omit<TypographyProps, 'textAlign'> {
    render: (record: RecordType, source?: string) => ReactNode;
}
//# sourceMappingURL=FunctionField.d.ts.map