/// <reference types="react" />
import PropTypes from 'prop-types';
import { FieldProps } from './types';
import { SxProps } from '@mui/system';
export declare const ImageField: {
    <RecordType extends Record<string, any> = Record<string, any>>(props: ImageFieldProps<RecordType>): JSX.Element;
    displayName: string;
    propTypes: {
        src: PropTypes.Requireable<string>;
        title: PropTypes.Requireable<string>;
        sortBy: PropTypes.Requireable<string>;
        sortByOrder: PropTypes.Requireable<"ASC" | "DESC">;
        source: PropTypes.Requireable<string>;
        label: PropTypes.Requireable<NonNullable<string | boolean | PropTypes.ReactElementLike>>;
        sortable: PropTypes.Requireable<boolean>;
        className: PropTypes.Requireable<string>;
        cellClassName: PropTypes.Requireable<string>;
        headerClassName: PropTypes.Requireable<string>;
        textAlign: PropTypes.Requireable<"inherit" | "left" | "right" | "center" | "justify">;
        emptyText: PropTypes.Requireable<string>;
    };
};
export declare const ImageFieldClasses: {
    list: string;
    image: string;
};
export interface ImageFieldProps<RecordType extends Record<string, any> = Record<string, any>> extends FieldProps<RecordType> {
    src?: string;
    title?: string;
    sx?: SxProps;
}
//# sourceMappingURL=ImageField.d.ts.map