import { ComponentType } from 'react';
import { CoreAdminUIProps } from 'ra-core';
export declare const AdminUI: ({ layout, catchAll, loading, loginPage, authCallbackPage, notification, ...props }: AdminUIProps) => JSX.Element;
export interface AdminUIProps extends CoreAdminUIProps {
    /**
     * The component used to display notifications
     *
     * @see https://marmelab.com/react-admin/Admin.html#notification
     * @example
     * import { Admin, Notification } from 'react-admin';
     * import { dataProvider } from './dataProvider';
     *
     * const MyNotification = () => <Notification autoHideDuration={5000} />;
     *
     * const App = () => (
     *     <Admin notification={MyNotification} dataProvider={dataProvider}>
     *         ...
     *     </Admin>
     * );
     */
    notification?: ComponentType;
}
//# sourceMappingURL=AdminUI.d.ts.map