import { ReactElement } from 'react';
import PropTypes from 'prop-types';
import { RaRecord, UpdateManyParams } from 'ra-core';
import { UseMutationOptions } from 'react-query';
import { ButtonProps } from './Button';
import { BulkActionProps } from '../types';
export declare const BulkUpdateWithUndoButton: {
    (props: BulkUpdateWithUndoButtonProps): JSX.Element;
    propTypes: {
        label: PropTypes.Requireable<string>;
        resource: PropTypes.Requireable<string>;
        selectedIds: PropTypes.Requireable<any[]>;
        icon: PropTypes.Requireable<PropTypes.ReactElementLike>;
        data: PropTypes.Validator<any>;
    };
};
export interface BulkUpdateWithUndoButtonProps<RecordType extends RaRecord = any, MutationOptionsError = unknown> extends BulkActionProps, ButtonProps {
    icon?: ReactElement;
    data: any;
    onSuccess?: () => void;
    onError?: (error: any) => void;
    mutationOptions?: UseMutationOptions<RecordType, MutationOptionsError, UpdateManyParams<RecordType>> & {
        meta?: any;
    };
}
//# sourceMappingURL=BulkUpdateWithUndoButton.d.ts.map