/// <reference types="react" />
import { RaThemeOptions } from '../theme';
/**
 * Button toggling the theme (light or dark).
 *
 * Enabled by default in the <AppBar> when the <Admin> component has a darkMode.
 *
 * @example
 * import { AppBar, ToggleThemeButton } from 'react-admin';
 *
 * const MyAppBar = () => (
 *     <AppBar toolbar={<ToggleThemeButton />} />
 * );
 *
 * const MyLayout = props => <Layout {...props} appBar={MyAppBar} />;
 */
export declare const ToggleThemeButton: (props: ToggleThemeButtonProps) => JSX.Element;
export interface ToggleThemeButtonProps {
    /**
     * @deprecated Set the lightTheme in the `<Admin>` component instead.
     */
    lightTheme?: RaThemeOptions;
    /**
     * @deprecated Set the darkTheme in the `<Admin>` component instead.
     */
    darkTheme?: RaThemeOptions;
}
//# sourceMappingURL=ToggleThemeButton.d.ts.map