import { ReactNode } from 'react';
import { SortPayload, FilterPayload } from 'ra-core';
import { FieldProps } from './types';
export declare const ArrayField: {
    <RecordType extends Record<string, any> = Record<string, any>>(props: ArrayFieldProps<RecordType>): JSX.Element;
    propTypes: {
        sortBy: import("prop-types").Requireable<string>;
        sortByOrder: import("prop-types").Requireable<"ASC" | "DESC">;
        source: import("prop-types").Requireable<string>;
        label: import("prop-types").Requireable<NonNullable<string | boolean | import("prop-types").ReactElementLike>>;
        sortable: import("prop-types").Requireable<boolean>;
        className: import("prop-types").Requireable<string>;
        cellClassName: import("prop-types").Requireable<string>;
        headerClassName: import("prop-types").Requireable<string>;
        textAlign: import("prop-types").Requireable<"inherit" | "left" | "right" | "center" | "justify">;
        emptyText: import("prop-types").Requireable<string>;
    };
    displayName: string;
};
export interface ArrayFieldProps<RecordType extends Record<string, any> = Record<string, any>> extends FieldProps<RecordType> {
    children?: ReactNode;
    perPage?: number;
    sort?: SortPayload;
    filter?: FilterPayload;
}
//# sourceMappingURL=ArrayField.d.ts.map