/// <reference types="react" />
/**
 * Test utility to simulate a preferred theme mode (light or dark)
 *
 * Do not use inside a browser.
 *
 * @example
 *
 * <ThemeTestWrapper mode="dark">
 *     <MyComponent />
 * <ThemeTestWrapper>
 */
export declare const ThemeTestWrapper: ({ mode, children, }: ThemeTestWrapperProps) => JSX.Element;
export interface ThemeTestWrapperProps {
    mode: 'light' | 'dark';
    children: JSX.Element;
}
//# sourceMappingURL=ThemeTestWrapper.d.ts.map